<?php

function tweet_blender_admin_page() {
 
 	$tb_option_names = array(
		// general configuration options
		'general_source_ids','general_timestamp_format','general_link_screen_names','general_link_hash_tags','general_link_urls','general_cache_ttl',
		// options related to widget
		'widget_show_photos','widget_show_source','widget_tweets_num',
		// options related to archive page
		'archive_show_photos','archive_show_source','archive_tweets_num'
	);
	 
    // Read in existing option values from database
	foreach ($tb_option_names as $opt_name) {
		$tb_o[$opt_name] = get_option('tb_' . $opt_name);
	}
		
	// set defaults
	if ($tb_o['widget_tweets_num'] < 1) {
		$tb_o['widget_tweets_num'] = 3;
	}
	if ($tb_o['archive_tweets_num'] < 1) {
		$tb_o['archive_tweets_num'] = 20;
	}

    // See if the user has posted us some information
    if( $_POST['tb_new_data'] == 'Y' ) {

		// validate input
		$errors = array();
		
		$spaces = '/\s+/';
		$_POST['general_source_ids'] = preg_replace($spaces,'',$_POST['general_source_ids']);
		$sources = split(',', $_POST['general_source_ids']);
		$sources = array_filter($sources);
		if (sizeof($sources) < 1) {
			$errors[] = "Please provide at least one screen name or hashtag";
		}

        // if all is good, save the posted value in the database
		if (sizeof($errors) < 1) {

			$_POST['general_cache_ttl'] = ceil(60*60 / 100 / sizeof($sources));
			$_POST['general_source_ids'] = join(',',$sources);
			
			foreach($tb_option_names as $post_key) {
				update_option('tb_' . $post_key,$_POST[$post_key]);
				$tb_o[$post_key] = $_POST[$post_key];
			}
	
	        // Put an options updated message on the screen
			$message = '<div class="updated"><p><strong>Settings saved</strong></p></div>';
		} else {
			$message = '<div class="error"><strong><ul><li>' . join('</li><li>',$errors) . '</li></ul></strong></div>';
			$tb_o = $_POST;
		}
    }
?>

<style type="text/css">
a.info-icon {
	-moz-opacity:.30; filter:alpha(opacity=30); opacity:.30;
}

a.info-icon:hover {
	-moz-opacity:1; filter:alpha(opacity=100); opacity:1;
}

a.info-icon img {
	vertical-align: middle;
}

#admin-links {
	float:right;
	display:inline;
	padding:15px;
}

</style>

<div class="wrap">
	<h2><?php _e('Tweet Blender', 'mt_trans_domain' ); ?></h2>
	<div id="admin-links">
	<a href="http://kirill-novitchenko.com/tweet-blender/" target="_blank">Homepage</a> &middot; 
	<a href="https://kino.lighthouseapp.com/projects/31440-tweet-blender-for-wordpress/tickets/new" target="_blank">Report a bug</a> &middot;
	<a href="https://kino.lighthouseapp.com/projects/31440-tweet-blender-for-wordpress/tickets/new" target="_blank">Request a feature</a>
	</div>

	<?php echo $message; ?>
	 
	<form name="form1" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
	<input type="hidden" name="tb_new_data" value="Y">


	<h3>General Settings</h3>
	<table class="form-table">
	<tr valign="top">
		<th scope="row"><label for="general_source_ids"><?php _e('Twitter Sources', 'mt_trans_domain' ); ?>: 
		<a class="info-icon" href="http://kirill-novitchenko.com/2009/05/select-twitter-sources/" target="_blank" title="Info"><img src="/wp-content/plugins/tweet-blender/img/info-kino.png"></a>
		</label></th>
		<td valign="top">
			<textarea name="general_source_ids" rows=2 cols=40><?php echo $tb_o['general_source_ids']; ?></textarea>
			<br/>
			<span class="setting-description">Screen names or hashtags separated with commas e.g. <b>#tweetblender</b> or <b>knovitchenko</b></span></td>
	</tr>
	<tr valign="top">
		<th scope="row"><label for="general_timestamp_format"><?php _e('Timestamp Format', 'mt_trans_domain' ); ?>:
		<a class="info-icon" href="http://kirill-novitchenko.com/2009/05/configure-timestamp-format/" target="_blank" title="Info"><img src="http://kirill-novitchenko.com/img/info-kino.png"></a>
		</label></th>
		<td><input type="text" name="general_timestamp_format" value="<?php echo $tb_o['general_timestamp_format']; ?>"> <span class="setting-description"><br/>
			leave blank = verbose from now ("4 minutes ago")<br/>
			d = Day of the month, 2 digits with leading zeros ("01")<br/>
			m = Numeric representation of a month, with leading zeros ("01")<br/>
			Y = A full numeric representation of a year, 4 digits ("2009")<br/>
			h = 12-hour format of an hour with leading zeros ("08")<br/>
			i = Minutes with leading zeros ("01")<br/>
			s = Seconds, with leading zeros ("01")<br/>
			<a href="http://kirill-novitchenko.com/2009/05/configure-timestamp-format/">additional format options &raquo;</a>
		</span></td>
	</tr>	
	<tr valign="top">
		<th class="th-full" colspan="2" scope="row">
		<label for="general_link_urls">
		<input type="checkbox" name="general_link_urls"<?php if ($tb_o['general_link_urls']) echo " checked"; ?>>
		<?php _e("Link http &amp; https URLs insde tweet text", 'mt_trans_domain' ); ?>
		<a class="info-icon" href="http://kirill-novitchenko.com/2009/05/link-urls-inside-tweets/" target="_blank" title="Info"><img src="http://kirill-novitchenko.com/img/info-kino.png"></a>
		</label> <span class="setting-description">Link would open in new window/tab</span>
		</th>
	</tr>
	<tr valign="top">
		<th class="th-full" colspan="2" scope="row">
		<label for="general_link_screen_names">
		<input type="checkbox" name="general_link_screen_names"<?php if ($tb_o['general_link_screen_names']) echo " checked"; ?>>
		<?php _e('Link @screenname inside tweet text', 'mt_trans_domain' ); ?>
		<a class="info-icon" href="http://kirill-novitchenko.com/2009/05/link-screen-names-in-tweets/" target="_blank" title="Info"><img src="http://kirill-novitchenko.com/img/info-kino.png"></a>
		</label> <span class="setting-description">Link would open in new window/tab</span>
		</th>
	</tr>
	<tr valign="top">
		<th class="th-full" colspan="2" scope="row">
		<label for="general_link_hash_tags">
		<input type="checkbox" name="general_link_hash_tags"<?php if ($tb_o['general_link_hash_tags']) echo " checked"; ?>>
		<?php _e("Link #hashtags insde tweet text", 'mt_trans_domain' ); ?>
		<a class="info-icon" href="http://kirill-novitchenko.com/2009/05/link-hashtags-in-tweets/" target="_blank" title="Info"><img src="http://kirill-novitchenko.com/img/info-kino.png"></a>
		</label> <span class="setting-description">Link would open in new window/tab</span>
		</th>
	</tr>
	<tr valign="top">
		<th class="th-full" scope="row">
		<label for="general_cache_ttl"><?php _e("Cache refresh period", 'mt_trans_domain' ); ?>:
		<a class="info-icon" href="http://kirill-novitchenko.com/tag/rate-limit/" target="_blank" title="Info"><img src="http://kirill-novitchenko.com/img/info-kino.png"></a>
		</label>
		</th>
		<td>
		<input type="text" disabled="true" size=3 name="general_cache_ttl" value="<?php echo $tb_o['general_cache_ttl']; ?>"> <span class="setting-description">Twitter has a maximum rate of connections per hour from single site. To avoid going over that limit, the responses from API are cached for the time period indicated here (in seconds).</span>
		</td>
	</tr>
	</table>

	<br/>
	<h3>Sidebar Widget Settings</h3>
	<table class="form-table">
	<tr valign="top">
		<th scope="row"><label for="widget_tweets_num"><?php _e('Maximum number of tweets to show', 'mt_trans_domain' ); ?>:
		<a class="info-icon" href="http://kirill-novitchenko.com/2009/05/choose-how-many-tweets-to-show/" target="_blank" title="Info"><img src="http://kirill-novitchenko.com/img/info-kino.png"></a>
		</label></th>
		<td>
		<select name="widget_tweets_num">
			<?php
			for ($i = 1; $i <= 10; $i++) {
				echo '<option value="' . $i . '"';
				if ($i == $tb_o['widget_tweets_num']) {
					echo ' selected';
				}
				echo '>' . $i . '</option>';
			}
		?></select> <span class="setting-description">combined from all sources, NOT per source</span></td>
	</tr>
	<tr valign="top">
		<th class="th-full" colspan="2" scope="row">
		<label for="widget_show_photos">
		<input type="checkbox" name="widget_show_photos"<?php if ($tb_o['widget_show_photos']) echo " checked"; ?>>
		<?php _e("Show user's photo for each tweet", 'mt_trans_domain' ); ?>
		<a class="info-icon" href="http://kirill-novitchenko.com/2009/05/show-user-avatars/" target="_blank" title="Info"><img src="http://kirill-novitchenko.com/img/info-kino.png"></a>
		</label>
		</th>
	</tr>
	<tr valign="top">
		<th class="th-full" colspan="2" scope="row">
		<label for="widget_show_source">
		<input type="checkbox" name="widget_show_source"<?php if ($tb_o['widget_show_source']) echo " checked"; ?>>
		<?php _e("Show tweet source", 'mt_trans_domain' ); ?>
		<a class="info-icon" href="http://kirill-novitchenko.com/2009/05/display-how-tweet-was-created/" target="_blank" title="Info"><img src="http://kirill-novitchenko.com/img/info-kino.png"></a>
		</label> <span class="setting-description">e.g. from web, from TweetDeck, etc.</span>
		</th>
	</tr>
	</table>
	
	<br/>
	<h3>Archive Page Settings</h3>
	<table class="form-table">
	<tr valign="top">
		<th scope="row"><label for="archive_tweets_num"><?php _e('Maximum number of tweets to show', 'mt_trans_domain' ); ?>:
		<a class="info-icon" href="http://kirill-novitchenko.com/2009/05/choose-how-many-tweets-to-show/" target="_blank" title="Info"><img src="http://kirill-novitchenko.com/img/info-kino.png"></a>
		</label></th>
		<td>
		<select name="archive_tweets_num">
			<?php
			for ($i = 10; $i <= 80; $i+=10) {
				echo '<option value="' . $i . '"';
				if ($i == $tb_o['archive_tweets_num']) {
					echo ' selected';
				}
				echo '>' . $i . '</option>';
			}
		?></select> <span class="setting-description">combined from all sources, NOT per source</span></td>
	</tr>
	<tr valign="top">
		<th class="th-full" colspan="2" scope="row">
		<label for="archive_show_photos">
		<input type="checkbox" name="archive_show_photos"<?php if ($tb_o['archive_show_photos']) echo " checked"; ?>>
		<?php _e("Show user's photo for each tweet", 'mt_trans_domain' ); ?>
		<a class="info-icon" href="http://kirill-novitchenko.com/2009/05/show-user-avatars/" target="_blank" title="Info"><img src="http://kirill-novitchenko.com/img/info-kino.png"></a>
		</label>
		</th>
	</tr>
	<tr valign="top">
		<th class="th-full" colspan="2" scope="row">
		<label for="archive_show_source">
		<input type="checkbox" name="archive_show_source"<?php if ($tb_o['archive_show_source']) echo " checked"; ?>>
		<?php _e("Show tweet source", 'mt_trans_domain' ); ?>
		<a class="info-icon" href="http://kirill-novitchenko.com/2009/05/display-how-tweet-was-created/" target="_blank" title="Info"><img src="http://kirill-novitchenko.com/img/info-kino.png"></a>
		</label> <span class="setting-description">e.g. from web, from TweetDeck, etc.</span>
		</th>
	</tr>
	</table>
	
	<p class="submit">
	<input type="submit" class="button-primary" value="<?php _e('Save Settings', 'mt_trans_domain' ) ?>" />
	</p>
</form>
</div>

<?php
 
}

?>
